<?php
/*********************************************************************************
 * The contents of this file are subject to the SugarCRM Public License Version
 * 1.1.3 ("License"); You may not use this file except in compliance with the
 * License. You may obtain a copy of the License at http://www.sugarcrm.com/SPL
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * All copies of the Covered Code must include on each user interface screen:
 *    (i) the "Powered by SugarCRM" logo and
 *    (ii) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.  See full license for
 * requirements.
 *
 * The Original Code is: SugarCRM Open Source
 * The Initial Developer of the Original Code is SugarCRM, Inc.
 * Portions created by SugarCRM are Copyright (C) 2004 SugarCRM, Inc.;
 * All Rights Reserved.
 * Contributor(s): ______________________________________.
 ********************************************************************************/
/*********************************************************************************
 * $Id: modules.php,v 1.49.2.1 2005/03/01 00:26:15 joey Exp $
 * Description:  Executes a step in the installation process.
 ********************************************************************************/

$moduleList = array();
// this list defines the modules shown in the top tab list of the app
$moduleList[] = 'Home';
$moduleList[] = 'iFrames';
$moduleList[] = 'Calendar';


$moduleList[] = 'Activities';

$moduleList[] = 'Contacts';
$moduleList[] = 'Accounts';
$moduleList[] = 'Leads';
$moduleList[] = 'Opportunities';




$moduleList[] = 'Cases';
$moduleList[] = 'Bugs';
$moduleList[] = 'Feeds';
$moduleList[] = 'Dashboard';



$moduleList[] = 'Emails';

// this list defines all of the module names and bean names in the app
// to create a new module's bean class, add the bean definition here
$beanList['Leads'] 			= 'Lead';
$beanList['Contacts'] 		= 'Contact';
$beanList['Accounts']		= 'Account';


$beanList['Opportunities']	= 'Opportunity';
$beanList['Cases']			= 'aCase';
$beanList['Notes']			= 'Note';



$beanList['Calls']			= 'Call';
$beanList['Emails']			= 'Email';
$beanList['Meetings']		= 'Meeting';
$beanList['Tasks']			= 'Task';
$beanList['Users']			= 'User';
$beanList['Currencies']			= 'Currency';
$beanList['Trackers']		= 'Tracker';
$beanList['Import']			= 'ImportMap';
$beanList['Import_1']		= 'SugarFile';
$beanList['Import_2']		= 'UsersLastImport';
$beanList['Versions']		= 'Version';
$beanList['Administration']	= 'Administration';















$beanList['CustomFields']		= 'CustomFields';
$beanList['Bugs'] 			= 'Bug';
$beanList['Releases']		= 'Release';
$beanList['Feeds'] 			= 'Feed';
$beanList['iFrames'] 			= 'iFrame';

// this list defines all of the files that contain the SugarBean class definitions from $beanList
// to create a new module's bean class, add the file definition here
$beanFiles['Lead'] 			= 'modules/Leads/Lead.php';
$beanFiles['Contact'] 		= 'modules/Contacts/Contact.php';
$beanFiles['Account']		= 'modules/Accounts/Account.php';
$beanFiles['Opportunity']	= 'modules/Opportunities/Opportunity.php';
$beanFiles['aCase']			= 'modules/Cases/Case.php';
$beanFiles['Note']			= 'modules/Notes/Note.php';



$beanFiles['Call']			= 'modules/Calls/Call.php';
$beanFiles['Email']			= 'modules/Emails/Email.php';
$beanFiles['Meeting']		= 'modules/Meetings/Meeting.php';
$beanFiles['iFrame']		= 'modules/iFrames/iFrame.php';
$beanFiles['Task']			= 'modules/Tasks/Task.php';
$beanFiles['User']			= 'modules/Users/User.php';
$beanFiles['Currency']			= 'modules/Currencies/Currency.php';
$beanFiles['Tracker']		= 'data/Tracker.php';
$beanFiles['ImportMap']		= 'modules/Import/ImportMap.php';
$beanFiles['SugarFile']		= 'modules/Import/SugarFile.php';
$beanFiles['UsersLastImport']= 'modules/Import/UsersLastImport.php';
$beanFiles['Administration']= 'modules/Administration/Administration.php';














$beanFiles['CustomFields']	= 'modules/CustomFields/CustomFields.php';
$beanFiles['Bug'] 			= 'modules/Bugs/Bug.php';
$beanFiles['Version'] 			= 'modules/Versions/Version.php';
$beanFiles['Release'] 			= 'modules/Releases/Release.php';
$beanFiles['Feed'] 			= 'modules/Feeds/Feed.php';

// added these lists for security settings for tabs
$modInvisList = array('Administration','Currencies','CustomFields','Dropdown','Dynamic','DynamicLayout','EmailTemplates','Help','Import','Manufacturers','MySettings','ProductBundles','ProductCategories','ProductTemplates','ProductTypes','Releases','Shippers','TaxRates','TeamNotices','Teams','Users','Versions');
$modInvisListActivities	= array('Calls', 'Meetings','Notes','Tasks');



if (file_exists('include/modules_override.php'))
{
	include('include/modules_override.php');
}
?>
